<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Sets the global logger to a `&amp;&#x27;static Log`."><meta name="keywords" content="rust, rustlang, rust-lang, set_logger"><title>set_logger in log - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="sidebar-items.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc fn"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../log/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../log/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><div class="sidebar-elems"><h2 class="location"><a href="index.html">In log</a></h2></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../log/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Function <a href="index.html">log</a>::<wbr><a class="fn" href="#">set_logger</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/log/lib.rs.html#1465-1467">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><div class="docblock item-decl"><pre class="rust fn"><code>pub fn set_logger(logger: &amp;'static dyn <a class="trait" href="trait.Log.html" title="trait log::Log">Log</a>) -&gt; Result&lt;(), <a class="struct" href="struct.SetLoggerError.html" title="struct log::SetLoggerError">SetLoggerError</a>&gt;</code></pre></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Sets the global logger to a <code>&amp;'static Log</code>.</p>
<p>This function may only be called once in the lifetime of a program. Any log
events that occur before the call to <code>set_logger</code> completes will be ignored.</p>
<p>This function does not typically need to be called manually. Logger
implementations should provide an initialization method that installs the
logger internally.</p>
<h2 id="availability"><a href="#availability">Availability</a></h2>
<p>This method is available even when the <code>std</code> feature is disabled. However,
it is currently unavailable on <code>thumbv6</code> targets, which lack support for
some atomic operations which are used by this function. Even on those
targets, <a href="fn.set_logger_racy.html"><code>set_logger_racy</code></a> will be available.</p>
<h2 id="errors"><a href="#errors">Errors</a></h2>
<p>An error is returned if a logger has already been set.</p>
<h2 id="examples"><a href="#examples">Examples</a></h2>
<div class='information'><div class='tooltip edition' data-edition="2018">ⓘ</div></div><div class="example-wrap"><pre class="rust rust-example-rendered edition"><code><span class="kw">use</span> <span class="ident">log</span>::{<span class="ident">error</span>, <span class="ident">info</span>, <span class="ident">warn</span>, <span class="ident">Record</span>, <span class="ident">Level</span>, <span class="ident">Metadata</span>, <span class="ident">LevelFilter</span>};

<span class="kw">static</span> <span class="ident">MY_LOGGER</span>: <span class="ident">MyLogger</span> <span class="op">=</span> <span class="ident">MyLogger</span>;

<span class="kw">struct</span> <span class="ident">MyLogger</span>;

<span class="kw">impl</span> <span class="ident">log::Log</span> <span class="kw">for</span> <span class="ident">MyLogger</span> {
    <span class="kw">fn</span> <span class="ident">enabled</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">metadata</span>: <span class="kw-2">&amp;</span><span class="ident">Metadata</span>) -&gt; <span class="ident">bool</span> {
        <span class="ident">metadata</span>.<span class="ident">level</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="ident">Level::Info</span>
    }

    <span class="kw">fn</span> <span class="ident">log</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">record</span>: <span class="kw-2">&amp;</span><span class="ident">Record</span>) {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">enabled</span>(<span class="ident">record</span>.<span class="ident">metadata</span>()) {
            <span class="macro">println!</span>(<span class="string">&quot;{} - {}&quot;</span>, <span class="ident">record</span>.<span class="ident">level</span>(), <span class="ident">record</span>.<span class="ident">args</span>());
        }
    }
    <span class="kw">fn</span> <span class="ident">flush</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {}
}

<span class="ident">log::set_logger</span>(<span class="kw-2">&amp;</span><span class="ident">MY_LOGGER</span>).<span class="ident">unwrap</span>();
<span class="ident">log::set_max_level</span>(<span class="ident">LevelFilter::Info</span>);

<span class="macro">info!</span>(<span class="string">&quot;hello log&quot;</span>);
<span class="macro">warn!</span>(<span class="string">&quot;warning&quot;</span>);
<span class="macro">error!</span>(<span class="string">&quot;oops&quot;</span>);</code></pre></div>
</div></details></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="log" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>